apiVersion: v1
data:
  SPRING_DATASOURCE_PASSWORD: P@ssw0rd
  SPRING_DATASOURCE_URL: jdbc:mysql://mysql:3306/assignment?allowPublicKeyRetrieval=true
  SPRING_DATASOURCE_USERNAME: root
kind: ConfigMap
metadata:
  name: myapp
---
apiVersion: v1
kind: Secret
metadata:
  name: secret
stringData:
  MYSQL_DATABASE: assignment
  MYSQL_PASSWORD: P@ssw0rd
  MYSQL_ROOT_PASSWORD: P@ssw0rd
  MYSQL_USER: root
---
apiVersion: v1
kind: Service
metadata:
  name: myapp
spec:
  ports:
  - name: http
    port: 8090
    protocol: TCP
    targetPort: 8090
  selector:
    app: myapp
  type: ClusterIP
---
apiVersion: v1
kind: Service
metadata:
  name: mysql
spec:
  ports:
  - port: 3306
    protocol: TCP
    targetPort: 3306
  selector:
    app: mysql
  type: ClusterIP
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: myapp
  name: myapp
spec:
  replicas: 1
  selector:
    matchLabels:
      app: myapp
  template:
    metadata:
      labels:
        app: myapp
    spec:
      containers:
      - envFrom:
        - configMapRef:
            name: myapp
        image: nulllpointer1111/maven:200823-ebba2ab
        livenessProbe:
          httpGet:
            path: /actuator/health
            port: my-port
          initialDelaySeconds: 100
          periodSeconds: 15
        name: myapp
        ports:
        - containerPort: 8090
          name: my-port
        readinessProbe:
          httpGet:
            path: /persons/
            port: my-port
          initialDelaySeconds: 100
          periodSeconds: 15
        resources:
          limits:
            cpu: "2"
            memory: 2000Mi
          requests:
            cpu: "0.5"
            memory: 1000Mi
      initContainers:
      - command:
        - sh
        - -c
        - until nc -vz mysql 3306; do echo waiting for mysql; sleep 2; done
        image: busybox:1.28
        name: init-mysql
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: mysql
  name: mysql
spec:
  replicas: 1
  selector:
    matchLabels:
      app: mysql
  template:
    metadata:
      labels:
        app: mysql
    spec:
      containers:
      - env:
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: MYSQL_DATABASE
              name: secret
        - name: MYSQL_ROOT_PASSWORD
          valueFrom:
            secretKeyRef:
              key: MYSQL_ROOT_PASSWORD
              name: secret
        image: mysql:8
        name: mysql
        ports:
        - containerPort: 3310
---
apiVersion: networking.k8s.io/v1beta1
kind: Ingress
metadata:
  name: myapp-ingress
spec:
  rules:
  - host: hello.myapp
    http:
      paths:
      - backend:
          serviceName: myapp
          servicePort: 8090
        path: /
  tls:
  - hosts:
    - hello.myapp
    secretName: myapp-tls
